/*
 * author: Darren Bounds <darren@sfhn.net>
 * copyright: Copyright (C) 2002 by Darren Bounds
 * license: This software is under GPL version 2 of license
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * packit official page at http://www.intrusense.com/~dbounds
 */

unsigned short display;
unsigned short linklayer;
unsigned short resolve;
unsigned short verbose;

char write_filename[MAX_CMDOPT_LEN];
char read_filename[MAX_CMDOPT_LEN];

struct icmp_d
{
    char icmp_type[20];   
    int icmp_type_int;  

    char icmp_code[20];
    int icmp_code_int; 
};

#ifndef _CAPTURE_FUNC
#define _CAPTURE_FUNC

int    packit_retrieve_tcp_flags();
void   capture_clean_exit(int sig);
void   capture_stats();
void   process_packet_data(unsigned char *user, 
           struct pcap_pkthdr *pkthdr, 
           unsigned char *packet);
void   display_tcp_data(unsigned char *packet, 
           char *time_stamp,
           struct libnet_ethernet_hdr *ehdr,
           struct libnet_ipv4_hdr *iphdr);
void    display_udp_data(unsigned char *packet, 
           char *time_stamp,
           struct libnet_ethernet_hdr *ehdr,
           struct libnet_ipv4_hdr *iphdr);
void    display_icmp_data(unsigned char *packet, 
           char *time_stamp,
           struct libnet_ethernet_hdr *ehdr,
           struct libnet_ipv4_hdr *iphdr);

#endif /* _CAPTURE_FUNC */
