/*
 * author: Darren Bounds <darren@sfhn.net>
 * copyright: Copyright (C) 2002 by Darren Bounds
 * license: This software is under GPL version 2 of license
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * packit official page at http://www.intrusense.com/~dbounds
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "../include/packit.h" 
#include "../include/inject.h"
#include "../include/error.h"

libnet_t *
packit_build_icmp(libnet_t *packet_d)
{
    switch(ihdr_o.ih_type)
    {
        case 0: case 8:
            hdrlen = PACKIT_ICMPV4_ECHO_H;
            break;

        case 3:
            hdrlen = PACKIT_ICMPV4_UNREACH_H;
            break;

        case 5:
            hdrlen = PACKIT_ICMPV4_REDIRECT_H;
            break;

        case 11:
            hdrlen = PACKIT_ICMPV4_TIMXCEED_H;
            break;

        case 13: case 14:
            hdrlen = PACKIT_ICMPV4_TS_H;
            break;

        case 17: case 18:
            hdrlen = PACKIT_ICMPV4_MASK_H;
            break;
    }

    if(libnet_build_icmpv4_echo(
        ihdr_o.ih_type,                     
        ihdr_o.ih_code,                 
        0,                                  
        ihdr_o.ih_id,                              
        ihdr_o.ih_seq,                                  
        payload,                   
        payload_s,                     
        packet_d,            
        0) == -1)
    {
        fprintf(stderr, "\nError: Unable to build ICMPv4 header: %s\n", libnet_geterror(packet_d));
        exit(EXIT_FAILURE);
    }

    return packet_d; 
}

