/*
 * author: Darren Bounds <darren@sfhn.net>
 * copyright: Copyright (C) 2002 by Darren Bounds
 * license: This software is under GPL version 2 of license
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * packit official page at http://www.intrusense.com/~dbounds
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "../include/packit.h"
#include "../include/inject.h"
#include "../include/error.h"


void
display_injection(unsigned short init_type, unsigned short count)
{
    char proto[5], flags[7];

    proto[0] = '\0';
    flags[0] = '\0';

    if(iphdr_o.protocol == IPPROTO_TCP)
    {
        fprintf(stderr, "IPv%d TCP %s.%d > %s.%d: ",
            iphdr_o.version,
            iphdr_o.saddr,
            thdr_o.th_sport,
            iphdr_o.daddr, 
            thdr_o.th_dport);

        if(iphdr_o.protocol == IPPROTO_TCP)
        {
            if(thdr_o.th_syn)
                strcat(flags, "S");

            if(thdr_o.th_ack)
                strcat(flags, "A");

            if(thdr_o.th_fin)
                strcat(flags, "F");

            if(thdr_o.th_rst)
                strcat(flags, "R");

            if(thdr_o.th_psh)
                strcat(flags, "P");

            if(thdr_o.th_urg)
                strcat(flags, "P");

            if(strlen(flags) < 1)
                fprintf(stderr, ". ");
            else
                fprintf(stderr, "%s ", flags);

            if(thdr_o.th_seqn)
                fprintf(stderr, "seq %ld ", thdr_o.th_seqn);

            if(thdr_o.th_ackn)
                fprintf(stderr, "ackn %ld ", thdr_o.th_ackn);

            fprintf(stderr, "win %d ", thdr_o.th_win);

            if(thdr_o.th_urp)
                fprintf(stderr, "urp %d ", thdr_o.th_urp);
        }

    }
    else if(iphdr_o.protocol == IPPROTO_UDP)
    {
        fprintf(stderr, "IPv%d UDP %s.%d > %s.%d ",
            iphdr_o.version,
            iphdr_o.saddr,
            uhdr_o.uh_sport,
            iphdr_o.daddr,
            uhdr_o.uh_dport);
    }
    else if(iphdr_o.protocol == IPPROTO_ICMP)
    {
        fprintf(stderr, "IPv%d ICMP %s > %s: type(%d) code(%d) ",
            iphdr_o.version,
            iphdr_o.saddr,
            iphdr_o.daddr,
            ihdr_o.ih_type,
            ihdr_o.ih_code);
    }

    if(init_type)
        fprintf(stderr, "raw4 ");
    else
        fprintf(stderr, "link ");

    fprintf(stderr, "\n");
    fprintf(stderr, "Writing packet(s) (%d): ", count);

    return;
}
  
