/*
 * author: Darren Bounds <darren@sfhn.net
 * copyright: Copyright (C) 2002 by Darren Bounds
 * license: This software is under GPL version 2 of license
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * packit official page at http://www.intrusense.com/~dbounds
 */

#include <stdio.h>
#include <stdlib.h>

#include "../include/version.h"
#include "../include/error.h"

void
usage()
{
    fprintf(stderr, "usage: packit [-options] 'expression'\n\n");
    fprintf(stderr, "Mode:\n");
    fprintf(stderr, "  -m mode     Runtime mode (default: injection)\n");
    fprintf(stderr, "\n");
    fprintf(stderr, "Packet capture:\n");
    fprintf(stderr, "  -c count    Number of packets to process\n"); 
    fprintf(stderr, "  -H          Display capture data in a more human readable format (slow)\n");
    fprintf(stderr, "  -i device   Select listening device\n");
    fprintf(stderr, "  -r file     Read data from file\n");
    fprintf(stderr, "  -v          Slightly more data (ie: TTL, ID, TOS)\n");
    fprintf(stderr, "  -w file     Write data to file\n");
    fprintf(stderr, "  -e          Display link-level data\n");
    fprintf(stderr, "\n");
    fprintf(stderr, "IPv4 packet injection:\n");
    fprintf(stderr, "  -t proto    Select protocol for injection (default: tcp) \n");
    fprintf(stderr, "IP\n");
    fprintf(stderr, "  -d address  Destination address\n");
    fprintf(stderr, "  -n id       Id (default: random)\n");
    fprintf(stderr, "  -O tos      Type of service\n");
    fprintf(stderr, "  -r          Random source address\n");
    fprintf(stderr, "  -s address  Source address\n");
    fprintf(stderr, "  -t ttl      Time to live (default: 128)\n");
    fprintf(stderr, "TCP/UDP\n");
    fprintf(stderr, "  -a ack      Acknowledgement number\n");
    fprintf(stderr, "  -D port     Destination port\n");
    fprintf(stderr, "  -F flags    Flags (format: -F UAPRSF)\n");
    fprintf(stderr, "  -p payload  Payload\n");
    fprintf(stderr, "  -q seq      Sequence number\n");
    fprintf(stderr, "  -S port     Source port (default: random)\n");
    fprintf(stderr, "  -u urg      Urgent pointer\n");	
    fprintf(stderr, "  -W size     Window size (default: 1500)\n");
    fprintf(stderr, "ICMP\n");
    fprintf(stderr, "  -C code     Code (default: 0)\n");
    fprintf(stderr, "  -K type     Type (default: 8)\n");
    fprintf(stderr, "  -N id       Id (default: random)\n");
    fprintf(stderr, "  -p payload  Payload\n");
    fprintf(stderr, "  -Q seq      Sequence number (default: random)\n");
    fprintf(stderr, "Ethernet\n");
    fprintf(stderr, "  -e enet     Source ethernet address\n");
    fprintf(stderr, "  -E enet     Destination ethernet address\n");
    fprintf(stderr, "General\n");
    fprintf(stderr, "  -b burst    Select the number of packets to inject each second (Max: 100)\n");
    fprintf(stderr, "  -c count    Number of packets to send\n");
    fprintf(stderr, "  -i device   Select injection device\n");
    fprintf(stderr, "  -w seconds  Interval between sending each packet\n");
    fprintf(stderr, "\n");
    fprintf(stderr, "packit %s by %s\n", PACKIT_VERSION, PACKIT_AUTHOR);

    exit(EXIT_SUCCESS);
}

